/*
 * StereoCameraControlPanel.java
 *
 * Created on June 9, 2006, 1:21 AM
 */

package sddm;

import javax.media.opengl.*;
import net.java.joglutils.*;
import javax.swing.*;

/**
 * This class is a GUI control panel for a StereoCamera
 * @author Erik J. Tollerud
 */
public class StereoCameraControlPanel extends javax.swing.JPanel {
    private StereoCamera cam;
    //private float transStep;
    //private float rotStep;
    
    /** Creates new form StereoCameraControlPanel */
    public StereoCameraControlPanel() {
        this(new StereoCamera());
    }
    /**
     *Creates new form StereoCameraControlPanel with specified camera
     *@param camera pre-instantiated camera
     */
    public StereoCameraControlPanel(StereoCamera camera) {
        this.cam = camera;
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        tiltUButton = new javax.swing.JButton();
        tiltDButton = new javax.swing.JButton();
        rotRButton = new javax.swing.JButton();
        rotLeftButton = new javax.swing.JButton();
        transFButton = new javax.swing.JButton();
        transBButton = new javax.swing.JButton();
        targInterCheckBox = new javax.swing.JCheckBox();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        transField = new javax.swing.JFormattedTextField(java.text.NumberFormat.getInstance());
        rotField = new javax.swing.JFormattedTextField(java.text.NumberFormat.getInstance());
        mouseField = new javax.swing.JFormattedTextField(java.text.NumberFormat.getInstance());
        jLabel3 = new javax.swing.JLabel();
        mouseWheelField = new javax.swing.JFormattedTextField(java.text.NumberFormat.getInstance());
        jLabel4 = new javax.swing.JLabel();
        nearFieldField = new javax.swing.JFormattedTextField(java.text.NumberFormat.getInstance());
        apertureField = new javax.swing.JFormattedTextField(java.text.NumberFormat.getInstance());
        farFieldField = new javax.swing.JFormattedTextField(java.text.NumberFormat.getInstance());
        focalLengthField = new javax.swing.JFormattedTextField(java.text.NumberFormat.getInstance());
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        eyeSepField = new javax.swing.JFormattedTextField(java.text.NumberFormat.getInstance());
        jLabel11 = new javax.swing.JLabel();
        fpsTextField = new javax.swing.JFormattedTextField(java.text.NumberFormat.getInstance());
        animateCheckBox = new javax.swing.JCheckBox();
        tieFocalToTargCheckBox = new javax.swing.JCheckBox();
        cameraSetButton = new javax.swing.JButton();
        targetButton = new javax.swing.JButton();
        pointButton = new javax.swing.JButton();

        tiltUButton.setText("tilt up");
        tiltUButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tiltUButtonActionPerformed(evt);
            }
        });

        tiltDButton.setText("tilt down");
        tiltDButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tiltDButtonActionPerformed(evt);
            }
        });

        rotRButton.setText("rotate right");
        rotRButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rotRButtonActionPerformed(evt);
            }
        });

        rotLeftButton.setText("rotate left");
        rotLeftButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rotLeftButtonActionPerformed(evt);
            }
        });

        transFButton.setText("translate forward");
        transFButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                transFButtonActionPerformed(evt);
            }
        });

        transBButton.setText("translate back");
        transBButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                transBButtonActionPerformed(evt);
            }
        });

        targInterCheckBox.setText("Target Point Interaction?");
        targInterCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        targInterCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));
        targInterCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                targInterCheckBoxActionPerformed(evt);
            }
        });

        jLabel1.setText("Translation Step:");

        jLabel2.setText("Rotation Step:");

        transField.setText("test");
        transField.setValue(1);

        rotField.setText("test");
        rotField.setValue(10);

        mouseField.setText("test");
        mouseField.setValue(1);

        jLabel3.setText("Mouse Sensitivity:");

        mouseWheelField.setText("test");
        mouseWheelField.setValue(0.1);

        jLabel4.setText("Wheel Sensitivity:");

        nearFieldField.setText("test");
        nearFieldField.setValue(cam.getFrustumSettings().nearField);
        nearFieldField.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                nearFieldFieldPropertyChange(evt);
            }
        });

        apertureField.setText("test");
        apertureField.setValue(cam.getFrustumSettings().cameraAperture);
        apertureField.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                apertureFieldPropertyChange(evt);
            }
        });

        farFieldField.setText("test");
        farFieldField.setValue(cam.getFrustumSettings().farField);
        farFieldField.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                farFieldFieldPropertyChange(evt);
            }
        });

        focalLengthField.setText("test");
        focalLengthField.setValue(cam.getFrustumSettings().cameraFocalLength);
        focalLengthField.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                focalLengthFieldPropertyChange(evt);
            }
        });

        jLabel7.setText("Near Field Dist:");

        jLabel8.setText("Far Field Dist:");

        jLabel9.setText("Focal Length: ");

        jLabel10.setText("Aperture:");

        eyeSepField.setText("test");
        eyeSepField.setValue(cam.getStereoSep());
        eyeSepField.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                eyeSepFieldPropertyChange(evt);
            }
        });

        jLabel11.setText("Eye Seperation:");

        fpsTextField.setText("test");
        fpsTextField.setValue(30);
        fpsTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fpsTextFieldActionPerformed(evt);
            }
        });

        animateCheckBox.setText("Animate? FPS:");
        animateCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        animateCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));
        animateCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                animateCheckBoxActionPerformed(evt);
            }
        });

        tieFocalToTargCheckBox.setText("Tie Focal Length to Target Point?");
        tieFocalToTargCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        tieFocalToTargCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));
        tieFocalToTargCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tieFocalToTargCheckBoxActionPerformed(evt);
            }
        });

        cameraSetButton.setText("Set Camera");
        cameraSetButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cameraSetButtonActionPerformed(evt);
            }
        });

        targetButton.setText("Target Origin");
        targetButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                targetButtonActionPerformed(evt);
            }
        });

        pointButton.setText("Target Point...");
        pointButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pointButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createSequentialGroup()
                                .add(9, 9, 9)
                                .add(rotLeftButton)
                                .add(28, 28, 28)
                                .add(rotRButton))
                            .add(layout.createSequentialGroup()
                                .add(79, 79, 79)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(tiltUButton)
                                    .add(tiltDButton))))
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                                .add(layout.createSequentialGroup()
                                    .add(11, 11, 11)
                                    .add(targInterCheckBox, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 166, Short.MAX_VALUE))
                                .add(layout.createSequentialGroup()
                                    .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                    .add(transFButton)))
                            .add(layout.createSequentialGroup()
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(transBButton))))
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                            .add(layout.createSequentialGroup()
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                                    .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                                            .add(layout.createSequentialGroup()
                                                .add(jLabel9)
                                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                                .add(focalLengthField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 38, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                            .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                                .add(layout.createSequentialGroup()
                                                    .add(30, 30, 30)
                                                    .add(jLabel10)
                                                    .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                                    .add(apertureField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 38, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                                .add(layout.createSequentialGroup()
                                                    .add(jLabel11)
                                                    .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                                    .add(eyeSepField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 38, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                                            .add(jLabel7)
                                            .add(layout.createSequentialGroup()
                                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                                                    .add(jLabel8)
                                                    .add(jLabel3))
                                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)))
                                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                            .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                                                .add(farFieldField)
                                                .add(mouseField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 38, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                            .add(nearFieldField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 38, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                                    .add(layout.createSequentialGroup()
                                        .addContainerGap(163, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                        .add(cameraSetButton)))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED))
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                                .add(43, 43, 43)
                                .add(tieFocalToTargCheckBox)
                                .add(40, 40, 40)))
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(jLabel4)
                            .add(animateCheckBox)
                            .add(jLabel2)
                            .add(jLabel1))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(fpsTextField)
                            .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                                .add(transField)
                                .add(rotField)
                                .add(mouseWheelField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))))
                .add(20, 20, 20))
            .add(layout.createSequentialGroup()
                .add(71, 71, 71)
                .add(targetButton)
                .add(49, 49, 49)
                .add(pointButton)
                .addContainerGap(84, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(tiltUButton)
                    .add(transFButton))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(rotRButton)
                            .add(targInterCheckBox))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(transBButton)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED))
                    .add(layout.createSequentialGroup()
                        .add(rotLeftButton)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(tiltDButton)
                            .add(cameraSetButton))))
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createSequentialGroup()
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(layout.createSequentialGroup()
                                        .add(27, 27, 27)
                                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                            .add(eyeSepField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                            .add(jLabel11)
                                            .add(farFieldField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                            .add(jLabel8)))
                                    .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                        .add(apertureField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                        .add(jLabel10)
                                        .add(nearFieldField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                        .add(jLabel7)
                                        .add(jLabel1)))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(focalLengthField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(jLabel9)
                                    .add(mouseField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(jLabel3)
                                    .add(jLabel4)))
                            .add(layout.createSequentialGroup()
                                .add(34, 34, 34)
                                .add(jLabel2)))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(animateCheckBox)
                            .add(fpsTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(tieFocalToTargCheckBox)))
                    .add(layout.createSequentialGroup()
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createSequentialGroup()
                                .add(53, 53, 53)
                                .add(mouseWheelField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                            .add(layout.createSequentialGroup()
                                .add(transField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(rotField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(targetButton)
                    .add(pointButton))
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

    private void pointButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pointButtonActionPerformed
        JPanel pointPanel = new JPanel();
        javax.vecmath.Vector3f targ = cam.getTargetLocation();
        JFormattedTextField xField = new JFormattedTextField(java.text.NumberFormat.getInstance());
        xField.setValue(targ.x);
        JFormattedTextField yField = new JFormattedTextField(java.text.NumberFormat.getInstance());
        yField.setValue(targ.y);
        JFormattedTextField zField = new JFormattedTextField(java.text.NumberFormat.getInstance());
        zField.setValue(targ.z);
        JLabel xLabel = new JLabel("x");
        JLabel yLabel = new JLabel("y");
        JLabel zLabel = new JLabel("z");
        
        pointPanel.add(xLabel);
        pointPanel.add(xField);
        pointPanel.add(yLabel);
        pointPanel.add(yField);
        pointPanel.add(zLabel);
        pointPanel.add(zField);
        
        JPanelDialog jpd = new JPanelDialog("Target Point",pointPanel);
        if(jpd.showAsModal()) {
            float x = ((Number)xField.getValue()).floatValue();
            float y = ((Number)yField.getValue()).floatValue();
            float z = ((Number)zField.getValue()).floatValue();
            cam.setTargetPoint(x,y,z);
            this.redisplayAttachedFrames();
        }
    }//GEN-LAST:event_pointButtonActionPerformed

    private void targetButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_targetButtonActionPerformed
        cam.setTargetPoint(0,0,0);
        
        this.redisplayAttachedFrames();
    }//GEN-LAST:event_targetButtonActionPerformed

    private void cameraSetButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cameraSetButtonActionPerformed
        CameraSetPanel csp = new CameraSetPanel(this.cam);
        JPanelDialog jpd = new JPanelDialog("Camera Settings",csp);
        if(jpd.showAsModal()) {
            csp.applyToCamera();
            this.redisplayAttachedFrames();
        }
    }//GEN-LAST:event_cameraSetButtonActionPerformed
    
    private void tieFocalToTargCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tieFocalToTargCheckBoxActionPerformed
        boolean b = tieFocalToTargCheckBox.isSelected();
        cam.setTieFocalLengthToTargetPoint(b);
        focalLengthField.setEnabled(!b);
        focalLengthField.setValue(cam.getFrustumSettings().cameraFocalLength);
    }//GEN-LAST:event_tieFocalToTargCheckBoxActionPerformed
    
    private void fpsTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fpsTextFieldActionPerformed
        javax.swing.JFrame[] jfs = ((StereoCameraControlFrame)this.getRootPane().getParent()).getAttachedFrames();
        int fps = ((Number)fpsTextField.getValue()).intValue();
        for (javax.swing.JFrame f :jfs) {
            if (f instanceof GLJFrame) {
                GLJFrame gljf = (GLJFrame)f;
                if (gljf.isAnimated()) {
                    if(fps > 0)
                        gljf.setAnimator(new com.sun.opengl.util.FPSAnimator(fps));
                    else
                        gljf.generateAnimator();
                }
            }
        }
    }//GEN-LAST:event_fpsTextFieldActionPerformed
    
    private void animateCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_animateCheckBoxActionPerformed
        javax.swing.JFrame[] jfs = ((StereoCameraControlFrame)this.getRootPane().getParent()).getAttachedFrames();
        int fps = ((Number)fpsTextField.getValue()).intValue();
        
        for(javax.swing.JFrame fr : jfs) {
            if (fr instanceof GLJFrame) {
                GLJFrame gljf = (GLJFrame)fr;
                if(animateCheckBox.isSelected()) {
                    if(fps > 0)
                        gljf.setAnimator(new com.sun.opengl.util.FPSAnimator(fps));
                    else
                        gljf.generateAnimator();
                } else
                    gljf.removeAnimator();
            }
        }
    }//GEN-LAST:event_animateCheckBoxActionPerformed
    
    private void targInterCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_targInterCheckBoxActionPerformed
        cam.drawSphereOnUpdate = targInterCheckBox.isSelected();
        this.redisplayAttachedFrames();
    }//GEN-LAST:event_targInterCheckBoxActionPerformed
    
    private void eyeSepFieldPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_eyeSepFieldPropertyChange
        if(evt.getPropertyName().equals("value")) {
            cam.setStereoSep(((Number)eyeSepField.getValue()).floatValue());
            this.redisplayAttachedFrames();
        }
    }//GEN-LAST:event_eyeSepFieldPropertyChange
    
    private void focalLengthFieldPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_focalLengthFieldPropertyChange
        if(evt.getPropertyName().equals("value")) {
            StereoCamera.FrustumSettings fs = cam.getFrustumSettings();
            fs.cameraFocalLength = ((Number)focalLengthField.getValue()).floatValue();
            cam.setFrustumSettings(fs);
            this.redisplayAttachedFrames();
        }
    }//GEN-LAST:event_focalLengthFieldPropertyChange
    
    private void apertureFieldPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_apertureFieldPropertyChange
        if(evt.getPropertyName().equals("value")){
            StereoCamera.FrustumSettings fs = cam.getFrustumSettings();
            fs.cameraAperture = ((Number)apertureField.getValue()).floatValue();
            cam.setFrustumSettings(fs);
            this.redisplayAttachedFrames();
        }
    }//GEN-LAST:event_apertureFieldPropertyChange
    
    private void farFieldFieldPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_farFieldFieldPropertyChange
        if(evt.getPropertyName().equals("value")){
            StereoCamera.FrustumSettings fs = cam.getFrustumSettings();
            fs.farField = ((Number)farFieldField.getValue()).floatValue();
            cam.setFrustumSettings(fs);
            this.redisplayAttachedFrames();
        }
    }//GEN-LAST:event_farFieldFieldPropertyChange
    
    private void nearFieldFieldPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_nearFieldFieldPropertyChange
        if(evt.getPropertyName().equals("value")){
            StereoCamera.FrustumSettings fs = cam.getFrustumSettings();
            fs.nearField = ((Number)nearFieldField.getValue()).floatValue();
            cam.setFrustumSettings(fs);
            this.redisplayAttachedFrames();
        }
    }//GEN-LAST:event_nearFieldFieldPropertyChange
    
    private void rotLeftButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rotLeftButtonActionPerformed
        if (this.targInterCheckBox.isSelected())
            cam.rotateAboutTargetPoint(getRotStep());
        else
            cam.yaw(getRotStep());
        redisplayAttachedFrames();
    }//GEN-LAST:event_rotLeftButtonActionPerformed
    
    private void tiltUButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tiltUButtonActionPerformed
        if (this.targInterCheckBox.isSelected())
            cam.tiltAboutTargetPoint(getRotStep());
        else
            cam.pitch(getRotStep());
        redisplayAttachedFrames();
    }//GEN-LAST:event_tiltUButtonActionPerformed
    
    private void tiltDButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tiltDButtonActionPerformed
        if (this.targInterCheckBox.isSelected())
            cam.tiltAboutTargetPoint(-getRotStep());
        else
            cam.pitch(-getRotStep());
        redisplayAttachedFrames();
    }//GEN-LAST:event_tiltDButtonActionPerformed
    
    private void transBButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_transBButtonActionPerformed
        if (this.targInterCheckBox.isSelected())
            cam.setTargetDistance(cam.getTargetDistance()-getTransStep());
        else
            cam.translate(-getTransStep());
        redisplayAttachedFrames();
    }//GEN-LAST:event_transBButtonActionPerformed
    
    private void transFButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_transFButtonActionPerformed
        if (this.targInterCheckBox.isSelected())
            cam.setTargetDistance(cam.getTargetDistance()+getTransStep());
        else
            cam.translate(getTransStep());
        redisplayAttachedFrames();
    }//GEN-LAST:event_transFButtonActionPerformed
    
    private void rotRButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rotRButtonActionPerformed
        if (this.targInterCheckBox.isSelected())
            cam.rotateAboutTargetPoint(-getRotStep());
        else
            cam.yaw(-getRotStep());
        redisplayAttachedFrames();
    }//GEN-LAST:event_rotRButtonActionPerformed
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox animateCheckBox;
    private javax.swing.JFormattedTextField apertureField;
    private javax.swing.JButton cameraSetButton;
    private javax.swing.JFormattedTextField eyeSepField;
    private javax.swing.JFormattedTextField farFieldField;
    private javax.swing.JFormattedTextField focalLengthField;
    private javax.swing.JFormattedTextField fpsTextField;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JFormattedTextField mouseField;
    private javax.swing.JFormattedTextField mouseWheelField;
    private javax.swing.JFormattedTextField nearFieldField;
    private javax.swing.JButton pointButton;
    private javax.swing.JFormattedTextField rotField;
    private javax.swing.JButton rotLeftButton;
    private javax.swing.JButton rotRButton;
    private javax.swing.JCheckBox targInterCheckBox;
    private javax.swing.JButton targetButton;
    private javax.swing.JCheckBox tieFocalToTargCheckBox;
    private javax.swing.JButton tiltDButton;
    private javax.swing.JButton tiltUButton;
    private javax.swing.JButton transBButton;
    private javax.swing.JButton transFButton;
    private javax.swing.JFormattedTextField transField;
    // End of variables declaration//GEN-END:variables
    /**
     * Returns the camera used by this control panel
     * @return  the camera used in this panel
     */
    public StereoCamera getCamera() {
        return cam;
    }
    /**
     * Sets the camera for this control panel
     * @param camera the camera to use in this panel
     */
    public void setCamera(StereoCamera camera) {
        cam = camera;
    }
    
    /**
     * Retrieves the step size for rotations
     * @return the rotational step size in degrees
     */
    public float getRotStep() {
        Number num = (Number)this.rotField.getValue();
        return num.floatValue();
    }
    
    /**
     * Sets the step size for rotations and updates the form
     * @param rotStep the new rotational step size
     */
    public void setRotStep(float rotStep) {
        this.rotField.setValue(new Float(rotStep));
    }
    
    /**
     * Retrieves the step size for translation
     * @return the translational step size
     */
    public float getTransStep() {
        Number num = (Number)this.transField.getValue();
        return num.floatValue();
    }
    
    /**
     * Sets the step size for translations and updates the form
     * @param transStep the new translational step size
     */
    public void setTransStep(float transStep) {
        this.transField.setValue(new Float(transStep));
    }
    /**
     * Retrieves the sensitivity for mouse motion events
     * @return the mouse motion semsitivity
     */
    public float getMouseSens() {
        Number num = (Number)this.mouseField.getValue();
        return num.floatValue();
    }
    
    /**
     * Sets the step size for mouse motion events
     * @param sensitivity the new mouse sensitivity
     */
    public void setMouseSens(float sensitivity) {
        this.mouseField.setValue(new Float(sensitivity));
    }
    /**
     * retrieves the sensitivity for mouse wheel events
     * @return the new wheel sensitivity
     */
    public float getMouseWheelSens() {
        Number num = (Number)this.mouseWheelField.getValue();
        return num.floatValue();
    }
    
    /**
     * Sets the sensitivity for mouse wheel events
     * @param sensitivity the new mouse wheel sensitivity
     */
    public void setMouseWheelSens(float sensitivity) {
        this.mouseWheelField.setValue(new Float(sensitivity));
    }
    /**
     * Retrieves the target point interaction mode
     * @return true if the the target point interaction mode is active
     */
    public boolean isTargetInteractionMode() {
        return this.targInterCheckBox.isSelected();
    }
    /**
     * Sets the target point interaction mode
     * @param b true to set the target point interaction mode active
     */
    public void setTargetInteractionMode(boolean b) {
        this.targInterCheckBox.setSelected(b);
    }
    /**
     * Repaints the frames attached to the parent StereoCameraControlFrame.  Assumes parent is a StereoCameraControlFrame
     */
    protected void redisplayAttachedFrames() {
        ((StereoCameraControlFrame)this.getRootPane().getParent()).redisplay();
    }
    /**
     * Gets all the camera settings from the StereoCamera object and uses them to set the panel settings
     */
    public void panelToCameraSettings() {
        StereoCamera.FrustumSettings fs = new StereoCamera.FrustumSettings();
        fs.cameraAperture = ((Number)this.apertureField.getValue()).floatValue();
        fs.farField = ((Number)this.farFieldField.getValue()).floatValue();
        fs.nearField = ((Number)this.nearFieldField.getValue()).floatValue();
        fs.cameraFocalLength = ((Number)this.focalLengthField.getValue()).floatValue();
        this.cam.setStereoSep(((Number)this.eyeSepField.getValue()).floatValue());
    }
    public void cameraSettingsToPanel() {
        StereoCamera.FrustumSettings fs = this.cam.getFrustumSettings();
        this.apertureField.setValue(fs.cameraAperture);
        this.farFieldField.setValue(fs.farField);
        this.nearFieldField.setValue(fs.nearField);
        this.focalLengthField.setValue(fs.cameraFocalLength);
        this.eyeSepField.setValue(this.cam.getStereoSep());
    }
}
