/*
 * HeightFieldModuleSetupPanel.java
 *
 * Created on June 21, 2006, 1:20 AM
 */

package sddm.modules;

import java.io.*;
import javax.swing.*;
import sddm.*;
import sddm.SDDModuleSetupPanel;
import sddm.data.HeightField;

/**
 *
 * @author  Erik J. Tollerud
 */
public class HeightFieldModuleSetupPanel extends SDDModuleSetupPanel {
    
    /** Creates new form HeightFieldModuleSetupPanel */
    public HeightFieldModuleSetupPanel() {
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        fileTextField = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        fileBrowseButton = new javax.swing.JButton();
        fileFormatComboBox = new javax.swing.JComboBox();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        granField = new javax.swing.JFormattedTextField(java.text.NumberFormat.getInstance());

        fileTextField.setText(System.getProperty("user.home"));

        jLabel1.setText("File Name");

        fileBrowseButton.setText("Browse...");
        fileBrowseButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fileBrowseButtonActionPerformed(evt);
            }
        });

        fileFormatComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Image", "Single-Line ASCII", "Multi-Line ASCII" }));

        jLabel2.setText("File Format:");

        jLabel3.setText("Initial Granularity");

        granField.setText("tester");
        granField.setValue(1);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(jLabel1)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 68, Short.MAX_VALUE)
                        .add(jLabel2)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(fileFormatComboBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(layout.createSequentialGroup()
                        .add(fileTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 196, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(fileBrowseButton))
                    .add(layout.createSequentialGroup()
                        .add(jLabel3)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(granField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 65, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(14, 14, 14)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(fileFormatComboBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel2))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(fileBrowseButton)
                    .add(fileTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel3)
                    .add(granField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents
    
    private void fileBrowseButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fileBrowseButtonActionPerformed
        JFileChooser jfc = new JFileChooser(new File(this.fileTextField.getText()));
        jfc.setFileSelectionMode(jfc.FILES_ONLY);
        jfc.setMultiSelectionEnabled(false);
        
        int indx = fileFormatComboBox.getSelectedIndex();
        switch (indx) {
            case 1:
            case 2:
                jfc.setFileFilter(new ExtensionFileFilter.TextFilter());
                break;
            case 0:
                jfc.setFileFilter(new ImageIOFileFilter());
        }
        jfc.setDialogType(jfc.OPEN_DIALOG);
        if(jfc.APPROVE_OPTION == jfc.showDialog(this,null))
            this.fileTextField.setText(jfc.getSelectedFile().getPath());
    }//GEN-LAST:event_fileBrowseButtonActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton fileBrowseButton;
    private javax.swing.JComboBox fileFormatComboBox;
    private javax.swing.JTextField fileTextField;
    private javax.swing.JFormattedTextField granField;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    // End of variables declaration//GEN-END:variables
    
    public HeightFieldModule makeModule(StereoCamera camera) {
        HeightField fieldToLoad = this.generateHeightField();
        HeightFieldModule mod = new HeightFieldModule(fieldToLoad, camera);
        mod.setGranularity(this.getGranularity());
            
        return mod;
    }
    
    public HeightField generateHeightField() {
        File f = new File(fileTextField.getText());
        HeightField.hfFileType type = HeightField.hfFileType.IMAGE;
        
        int indx = this.fileFormatComboBox.getSelectedIndex();
        if (indx == 1)
            type = HeightField.hfFileType.ASCII_1D;
        else if (indx == 2)
            type = HeightField.hfFileType.ASCII_2D;
        HeightField ret = new HeightField();
        try {
            ret = new HeightField(f, type);
        } catch (IOException e) {
            javax.swing.JOptionPane.showMessageDialog(null, "IO Error while loading file, loading default HeightField:\n"+e.getMessage(), "Height Field Load Error",javax.swing.JOptionPane.ERROR_MESSAGE);
        } catch (FileFormatException e) {
            javax.swing.JOptionPane.showMessageDialog(null, "Inccorect file format loading default HeightField:\n"+e.getMessage(), "Height Field Load Error",javax.swing.JOptionPane.ERROR_MESSAGE);
        }
        return ret;
    }
    public int getGranularity() {
        Number n = (Number)this.granField.getValue();
        return n.intValue();
    }
    
    
        
}
